
package form.edit;

import form.data.*;
import java.awt.*;
import java.awt.event.*;

public class FormProperties extends Dialog implements ActionListener , KeyListener , MouseListener{

    private PropertyData pd = null;
    private static String thisTitle = "Form Properties";
    private TextField codebase = null;
    private TextField name = null;
    private TextField title = null;
    private TextField cgiLocation = null;
    private TextField width = null;
    private TextField height = null;
    //private TextField archive = null;

    public FormProperties(PropertyData pod,Frame frame){
	super(frame, thisTitle,true);
    	new WindowCloser(this);
	
	pd = pod;

	addMouseListener(this);
	GridBagLayout gridBag = new GridBagLayout();
	setLayout(gridBag);
	GridBagConstraints cons = new GridBagConstraints();
	cons.gridwidth = GridBagConstraints.REMAINDER;
	cons.fill = GridBagConstraints.BOTH;
	cons.weightx = 1.0;

	Label lab = null;

	lab = new Label("Codebase");
	gridBag.setConstraints(lab,cons);
	add(lab);

	codebase = new TextField();
	gridBag.setConstraints(codebase,cons);
	add(codebase);

	lab = new Label("Name");
	gridBag.setConstraints(lab,cons);
	add(lab);

	name = new TextField();
	gridBag.setConstraints(name,cons);
	add(name);

	lab = new Label("Title");
	gridBag.setConstraints(lab,cons);
	add(lab);

	title = new TextField();
	gridBag.setConstraints(title,cons);
	add(title);

	lab = new Label("CGI Location");
	gridBag.setConstraints(lab,cons);
	add(lab);

	cgiLocation = new TextField();
	gridBag.setConstraints(cgiLocation,cons);
	add(cgiLocation);

	lab = new Label("Height");
	gridBag.setConstraints(lab,cons);
	add(lab);

	height = new TextField();
	gridBag.setConstraints(height,cons);
	add(height);

	lab = new Label("Width");
	gridBag.setConstraints(lab,cons);
	add(lab);

	width = new TextField();
	gridBag.setConstraints(width,cons);
	add(width);

/*
	lab = new Label("Archive");
	gridBag.setConstraints(lab,cons);
	add(lab);

	archive = new TextField();
	gridBag.setConstraints(archive,cons);
	add(archive);
*/

	cons.anchor = GridBagConstraints.CENTER;
	cons.gridwidth = 1;
	Button ok = new Button("OK");
	ok.setActionCommand("ok");
	ok.addActionListener(this);
	gridBag.setConstraints(ok, cons);
	add(ok);

	Button cancel = new Button("Cancel");
	cancel.setActionCommand("cancel");
	cancel.addActionListener(this);
	gridBag.setConstraints(cancel, cons);
	add(cancel);

        setBounds(30, 20, 400, 400);

	init();

    }

    public void init(){
        codebase.setText(pd.getCodebase());
	name.setText(pd.getName());
	title.setText(pd.getTitle());
	cgiLocation.setText(pd.getCgiLocation());
	width.setText(pd.getWidth());
	height.setText(pd.getHeight());
	//archive.setText(pd.getArchive());
    }

    public void actionPerformed(ActionEvent e) {

	if (e.getActionCommand().equals("ok")){
    	   pd.setCodebase(codebase.getText());
    	   pd.setName(name.getText());
    	   pd.setTitle(title.getText());
    	   pd.setCgiLocation(cgiLocation.getText());
    	   pd.setHeight(height.getText());
    	   pd.setWidth(width.getText());
	   //pd.setArchive(archive.getText());
	}
	else if (e.getActionCommand().equals("cancel")){
	  init();
	}

	//must be done with form so hide it
	setVisible(false);
    }



  public void keyPressed(KeyEvent e) {}
  public void keyReleased(KeyEvent e) {
      if (e.getKeyCode()==e.VK_ENTER) {
	//answer = tf.getText();
	setVisible(false);
      }
  }

  public void keyTyped(KeyEvent e) {
  }



  public void mouseClicked(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
