
package form.edit;

import form.data.*;
import form.comp.*;
import java.awt.*;
import java.awt.event.*;

public class Passwords extends Dialog implements ActionListener , KeyListener , MouseListener{

    private PasswordData pd = null;
    private static String thisTitle = "Passwords";
    private TextField name = null;
    private TextField description = null;
    private TextField user = null;
    private TextField pass = null;
    private TextField host = null;
    private TextArea passwords = null;

    public Passwords(PasswordData pad,Frame frame){
	super(frame, thisTitle,true);

	pd = pad;

    	new WindowCloser(this);

	addMouseListener(this);
	GridBagLayout gridBag = new GridBagLayout();
	setLayout(gridBag);
	GridBagConstraints cons = new GridBagConstraints();
	cons.gridwidth = GridBagConstraints.REMAINDER;
	cons.fill = GridBagConstraints.BOTH;
	cons.weightx = 0.0;

	Label lab = null;

	lab = new Label("Name");
	add(lab);

	cons.weightx = 1.0;

	name = new TextField();
	gridBag.setConstraints(name,cons);
	add(name);

	lab = new Label("Description");
	add(lab);

	description = new TextField();
	gridBag.setConstraints(description,cons);
	add(description);



	lab = new Label("User Name");
	add(lab);


	user = new TextField();
	gridBag.setConstraints(user,cons);
	add(user);

	lab = new Label("Password");
	add(lab);


	pass = new TextField();
	gridBag.setConstraints(pass,cons);
	add(pass);


	lab = new Label("Host Name");
	add(lab);


	host = new TextField();
	gridBag.setConstraints(host,cons);
	add(host);

	
	lab = new Label("Current passwords");
	gridBag.setConstraints(lab,cons);
	add(lab);

	passwords = new TextArea(5,10);
	gridBag.setConstraints(passwords,cons);
	passwords.addMouseListener(this);
	passwords.setEditable(false);
	add(passwords);

	cons.anchor = GridBagConstraints.CENTER;
	cons.gridwidth = 1;
	Button add = new Button("Add");
	add.addActionListener(this);
	gridBag.setConstraints(add, cons);
	add(add);

	Button edit = new Button("Edit");
	edit.addActionListener(this);
	gridBag.setConstraints(edit, cons);
	add(edit);

	Button remove = new Button("Remove");
	remove.addActionListener(this);
	gridBag.setConstraints(remove, cons);
	add(remove);

	Button cancel = new Button("Cancel");
	cancel.setActionCommand("cancel");
	cancel.addActionListener(this);
	gridBag.setConstraints(cancel, cons);
	add(cancel);

	init();

        setBounds(30, 20, 500, 320);

    }

    public void init(){
	String list = pd.passwordList();
	if (list != null)
	   passwords.setText(list);
	name.setText("");
	description.setText("");
	user.setText("");
	pass.setText("");
	host.setText("");
    }

    public void actionPerformed(ActionEvent e) {

	if (e.getActionCommand().equals("Add")){
		String[] newPass = new String[5];
		newPass[0] = name.getText();
		newPass[1] = description.getText();
		newPass[2] = user.getText();
		newPass[3] = pass.getText();
		newPass[4] = host.getText();
		pd.add(newPass);
		init();
	}
	else if (e.getActionCommand().equals("Edit")){
	    editPass(null);
	}
	else if (e.getActionCommand().equals("Remove")){
	    removePass(null);
	}
	else if (e.getActionCommand().equals("cancel")){
	  init();
	  dispose();
	}

    }



  public void keyPressed(KeyEvent e) {}
  public void keyReleased(KeyEvent e) {
      if (e.getKeyCode()==e.VK_ENTER) {
	//answer = tf.getText();
	setVisible(false);
      }
  }

  public void keyTyped(KeyEvent e) {
  }



  public void mouseClicked(MouseEvent e) {
        if ( (e.getComponent() == passwords) && (e.getClickCount() == 2) ) {
           String selectedName = passwords.getSelectedText();
           if (selectedName != null){
		removePass(selectedName);
	   }
	}
   }

	private void editPass(String selectedName){
		AskDialog ad = new AskDialog("Edit password","Enter the name of the password you wish to edit",selectedName);
		String editName = ad.answer();
		String old[] = pd.get(editName);
		init();
		name.setText(old[0]);
		description.setText(old[1]);
		user.setText(old[2]);
		pass.setText(old[3]);
		host.setText(old[4]);
	}

  	private void removePass(String selectedName){
		AskDialog ad = new AskDialog("Remove password","Enter the name of the password you wish to remove",selectedName);
		String nameToRem = ad.answer();
		String old[] = pd.remove(nameToRem);
		init();
		name.setText(old[0]);
		description.setText(old[1]);
		user.setText(old[2]);
		pass.setText(old[3]);
		host.setText(old[4]);
	}

  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
}
